//
//  DataPoit.h
//  
//
//  Created by Cedric John on Sat Nov 16 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
// DataPoint defines 1 point of data being drawned in a view. It knows how to plot itself accordging to 3 variables
// top, left and right, in a triangle!

#import <Foundation/Foundation.h>
#import <Cocoa/Cocoa.h>
#import "PDFView.h"
#import "Controller.h"
#import "MyDocument.h"
#import "math.h"

@class Controller, PDFView, MyDocument;

@interface DataPoint : NSView {
    NSString *sample; // the name of the sample
    NSDecimalNumber *height; // the height of the sample
    NSDecimalNumber *top; // the top most value
    NSDecimalNumber *left; // the lower left value
    NSDecimalNumber *right; // the lower right value
    NSColor *pointColor; // the color of the point
    BOOL plotReady; // a flag to check if the point is ready to plot
    int plotFactor; // scaling factor
    BOOL isDrawn; // check wether the point is being drawned
    BOOL isSelected; //check if selected
    BOOL isIcon; //if the view is used as a way to draw a popUpIcon
    int plotShape; // the selected shape
    int indexInArray; // the index of point in its array
    float sizeRatio;
    NSImage *pointImage; //icon
    NSMutableArray *dataSerie; // the serie of data the point is in
}

+ (id) initForLegendAtPoint:(NSPoint)point withColor:(NSColor *)color andShape:(int)shape;
- (NSComparisonResult)  sortArray:(DataPoint *) otherPoint;
- (NSString *) sample;
- (void) setSample: (NSString *) value; // sets the sample name
- (void) setHeight: (NSDecimalNumber *) value; // sets the height
- (void) setTop: (NSDecimalNumber *) value; // sets the top
- (void) setLeft: (NSDecimalNumber *) value;// sets the left
- (void) setRight: (NSDecimalNumber *) value; // sets the right
- (void) setShape: (NSPopUpButton *) shape; // sets the shape
- (void) setColor: (NSColor *) color; // sets the color
- (void) setFactor: (id) factor; // sets the size factor for the point
- (void) setViewRatio: (NSDecimalNumber *) ratio;
- (void) setGradient: (NSMutableDictionary *)gradDic;
- (void) setIsIcon;
- (void) calculateRect;
- (float) Xlocation;
- (float) Ylocation;
- (void) setDataSerie: (NSMutableArray *) theDataSerie; // sets the dataserie
- (void) setDraw: (NSButton *) isVisibleButton; // sets the checks wether the receivers draws
- (void) setShapeForRep:(int) shape; // sets the shape used to draw the pop-up liste
- (void) checkHighlight: (NSRect) theRect; // checks wether the rect of the receiver falls in the rect selected by the unser, and in case sets isSelected to YES
- (BOOL) isSelected; // determines wether the receiver is selected and remove it from its superview
- (BOOL) checkSelected; // determines wether the receiver is selected
- (void) deselect;
- (void) select;



-(NSString *) sample;
-(NSDecimalNumber *) height;
-(NSDecimalNumber *) top;
-(NSDecimalNumber *) left;
-(NSDecimalNumber *) right;
-(NSColor *) color;-(int) shape;
-(NSImage *) symbolImage;
-(NSData *)symbolPDF;


- (void) plotDataInView: (NSView *) plotView;
- (void) removeDataInView: (NSView *) plotView;


@end
