/* TXTParser a class to parse txt files into a mutable array, using a panel to control the action*/

#import <Cocoa/Cocoa.h>
#import "DataPoint.h"

@class DataPoint, MyDocument;

@interface TXTParser : NSObject
{
    IBOutlet NSPanel *txtPanel;
    IBOutlet NSPopUpButton *samplePop;
    IBOutlet NSPopUpButton *heightPop;
    IBOutlet NSPopUpButton *topPop;
    IBOutlet NSPopUpButton *leftPop;
    IBOutlet NSPopUpButton *rightPop;
    IBOutlet MyDocument *document;
    IBOutlet NSWindow *documentWindow;
    IBOutlet NSMatrix *removeZeroMatrix;
    
    NSMutableArray *dataFile;
    NSMutableString *captionString; //the data string
    NSMutableString *titleString;
    
    BOOL rowName;
    int removeZeros;
    int columnControl; //to check how many columns are missing, if less than 5 columns
    
}



- (IBAction)parseTXT:(id)sender;
- (void)performParseTXT;
- (IBAction)toggleFirstRawIsName:(id)sender;
- (IBAction)toggleRemoveZeros:(id)sender;
- (BOOL) getDataFromFile:(NSString *) dataString;
- (void) getDataFromPboard:(NSString *)dataString; //invoqued by services and copy/paste
- (IBAction)cancelInclude:(id)sender;
- (void) prepareData;
- (NSMutableDictionary *) dataFile;
@end
